<?php defined('_JEXEC') or die('Restricted access');

/**
* @version		1.0
* @package		DJ Classifieds
* @subpackage	DJ Classifieds SizPay Payment Plugin
* @copyright	CopyRight SizPay
* @autor url	http://www.modulebank.ir/
* @autor email	support@modulebank.ir
* 
*/

jimport('joomla.event.plugin');
// $lang = JFactory::getLanguage(); $lang->load('plg_djclassifiedspayment_djcfSizpay',JPATH_ADMINISTRATOR);

class plgdjclassifiedspaymentdjcfSizpay extends JPlugin
{
	function plgdjclassifiedspaymentdjcfSizpay( &$subject, $config)
	{
		parent::__construct($subject, $config);
		//$this->loadLanguage('plg_djcfSizpay');
		$params["plugin_name"] = "djcfSizpay";
		$params["icon"] = "sizpay_icon.png";
		$params["logo"] = "sizpay_overview.png";
		$params["description"] = 'DJ Classifieds SizPay payment';
		$params["payment_method"] = 'SizPay';
		$params["currency_code"] = $this->params->get("currency_code");
		$params["merchant"] = $this->params->get("merchant");
		$params["terminal"] = $this->params->get("terminal");
		$params["username"] = $this->params->get("username");
		$params["password"] = $this->params->get("password");
		$this->params = $params;
	}

	function onProcessPayment()
	{
		$html = "";
		$id = JRequest::getInt('id','0');
		$ptype = JRequest::getVar('ptype','');
		if($ptype == $this->params["plugin_name"])
		{
			$action = JRequest::getVar('pactiontype','');
			switch ($action)
			{
				case "process" :
					$html = $this->process($id);
					break;
				case "notify" :
					$html = $this->_notify_url();
					break;
				case "paymentmessage" :
					$html = $this->_paymentsuccess();
					break;
				default :
					$html = $this->process($id);
					break;
			}
		}
		return $html;
	}

	function _notify_url()
	{
		$db = JFactory::getDBO();
		$par = &JComponentHelper::getParams( 'com_djclassifieds' );
		$user = JFactory::getUser();
		$id = JRequest::getInt('id','0');
		$Status = 0;
		$err = 'تراکنش ناموفق';
		if (isset($_REQUEST['ResCod']) && in_array($_REQUEST['ResCod'], array('0', '00')))
		{
			$client = new SoapClient('https://rt.sizpay.ir/KimiaIPGRouteService.asmx?WSDL');
			$result = $client->Confirm2($parameters = array(
					'MerchantID'  => $this->params['merchant'],
					'TerminalID'  => $this->params['terminal'],
					'UserName'    => $this->params['username'],
					'Password'    => $this->params['password'],
					'Token'       => $_REQUEST['Token'],
					'SignData'    => ''
				))->Confirm2Result;
			$result = json_decode($result);
			if (isset($result->ResCod) && in_array($result->ResCod, array('0', '00')))
			{
				$Status = true;
				$err = "تراکنش با موفقیت انجام شد.";
			}
			else
			{
				$Status = @$result->ResCod;
				$err = 'نتیجه استعلام پرداخت "نامعتبر" می باشد . ' . @$result->Message;
			}
		}
		else
		{
			$Status = @$_REQUEST['ResCod'];
			$err = 'تراکنش ناموفق . ' . @$_REQUEST['Message'];
		}
		if ($Status === true)
		{
			$query = "SELECT p.* FROM #__djcf_payments p WHERE p.id='".$id."' ";
			$db->setQuery($query);
			$payment = $db->loadObject();
			if($payment)
			{
				$query = "UPDATE #__djcf_payments SET status='Completed',transaction_id='".$result->TrnsID."' WHERE id=".$id." AND method='djcfSizpay'";
				$db->setQuery($query);
				$db->query();

				if($payment->type==2)
				{
					$date_sort = date("Y-m-d H:i:s");
					$query = "UPDATE #__djcf_items SET date_sort='".$date_sort."' WHERE id=".$payment->item_id." ";
					$db->setQuery($query);
					$db->query();
				}
				else if($payment->type==1)
				{
					$query = "SELECT p.points FROM #__djcf_points p WHERE p.id='".$payment->item_id."' ";
					$db->setQuery($query);
					$points = $db->loadResult();
					$query = "INSERT INTO #__djcf_users_points (`user_id`,`points`,`description`) VALUES ('".$payment->user_id."','".$points."','".JText::_('COM_DJCLASSIFIEDS_POINTS_PACKAGE')." SizPay <br />".JText::_('COM_DJCLASSIFIEDS_PAYMENT_ID').' '.$payment->id."')";
					$db->setQuery($query);
					$db->query();
				}
				else
				{
					$query = "SELECT c.* FROM #__djcf_items i, #__djcf_categories c WHERE i.cat_id=c.id AND i.id='".$payment->item_id."' ";
					$db->setQuery($query);
					$cat = $db->loadObject();
					$pub = 0;
					if(($cat->autopublish=='1') || ($cat->autopublish=='0' && $par->get('autopublish')=='1'))
					{
						$pub = 1;
					}
					$query = "UPDATE #__djcf_items SET payed=1, pay_type='', published='".$pub."' WHERE id=".$payment->item_id." ";
					$db->setQuery($query);
					$db->query();
				}
				exit('<p style="font:12px Tahma; direction:rtl;text-align:center;color:#ff0000">پرداخت با موفقیت ثبت شد.<br />شماره پیگیری : '.$result->TrnsID.'.</p>');
			}
			else
			{
				exit('<p style="font:12px Tahma; direction:rtl;text-align:center;color:#ff0000">اطلاعات سفارش معتبر نیست. جهت پیگیری این خطا را به مدیریت سایت اطلاع دهید.<br />شماره سفارش : '.$id.'<br />شماره پیگیری : '.$result->TrnsID.'.</p>');
			}
		}
		else
		{
			$query = "UPDATE #__djcf_payments SET status='err_".$Status."',transaction_id='".$_REQUEST['Token']."' WHERE id=".$id." AND method='djcfSizpay'";
			$db->setQuery($query);
			$db->query();
			exit('<p style="font:12px Tahma; direction:rtl;text-align:center;color:#ff0000">'.$err.'</p>');
		}
	}

	function process($id)
	{
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
		jimport( 'joomla.database.table' );
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();
		$Itemid = JRequest::getInt("Itemid",'0');
		$par = JComponentHelper::getParams( 'com_djclassifieds' );
		$user = JFactory::getUser();
		$ptype = JRequest::getVar('ptype');
		$type = JRequest::getVar('type','');
		$row = JTable::getInstance('Payments', 'DJClassifiedsTable');

		if($type=='prom_top')
		{
			$query ="SELECT i.* FROM #__djcf_items i WHERE i.id=".$id." LIMIT 1";
			$db->setQuery($query);
			$item = $db->loadObject();
			if(!isset($item)){
				$message = JText::_('COM_DJCLASSIFIEDS_WRONG_AD');
				$redirect="index.php?option=com_djclassifieds&view=items&cid=0";
			}
			$row->item_id = $id;
			$row->user_id = $user->id;
			$row->method = $ptype;
			$row->status = 'Start';
			$row->ip_address = $_SERVER['REMOTE_ADDR'];
			$row->price = $par->get('promotion_move_top_price',0);
			$row->type=2;
			$row->store();
			$amount = $par->get('promotion_move_top_price',0);
			$itemname = $item->name;
			$item_id = $row->id;
			$item_cid = '&cid='.$item->cat_id;
		}
		else if($type=='points')
		{
			$query ="SELECT p.* FROM #__djcf_points p WHERE p.id=".$id." LIMIT 1";
			$db->setQuery($query);
			$points = $db->loadObject();
			if(!isset($item)){
				$message = JText::_('COM_DJCLASSIFIEDS_WRONG_POINTS_PACKAGE');
				$redirect="index.php?option=com_djclassifieds&view=items&cid=0";
			}
			$row->item_id = $id;
			$row->user_id = $user->id;
			$row->method = $ptype;
			$row->status = 'Start';
			$row->ip_address = $_SERVER['REMOTE_ADDR'];
			$row->price = $points->price;
			$row->type=1;
			$row->store();
			$amount = $points->price;
			$itemname = $points->name;
			$item_id = $row->id;
			$item_cid = '';
		}
		else
		{
			$query = "SELECT i.*, c.price as c_price FROM #__djcf_items i LEFT JOIN #__djcf_categories c ON c.id=i.cat_id WHERE i.id=".$id." LIMIT 1";
			$db->setQuery($query);
			$item = $db->loadObject();
			if(!isset($item)){
				$message = JText::_('COM_DJCLASSIFIEDS_WRONG_AD');
				$redirect="index.php?option=com_djclassifieds&view=items&cid=0";
			}
			$amount = 0;
			if(strstr($item->pay_type, 'cat')){
				$amount += $item->c_price/100;
			}
			if(strstr($item->pay_type, 'duration_renew')){
				$query = "SELECT d.price_renew FROM #__djcf_days d WHERE d.days=".$item->exp_days;
				$db->setQuery($query);
				$amount += $db->loadResult();
			}else if(strstr($item->pay_type, 'duration')){
				$query = "SELECT d.price FROM #__djcf_days d WHERE d.days=".$item->exp_days;
				$db->setQuery($query);
				$amount += $db->loadResult();
			}
			$query = "SELECT p.* FROM #__djcf_promotions p WHERE p.published=1 ORDER BY p.id ";
			$db->setQuery($query);
			$promotions=$db->loadObjectList();
			foreach($promotions as $prom){
				if(strstr($item->pay_type, $prom->name)){
					$amount += $prom->price;
				}
			}
			/*$query = 'DELETE FROM #__djcf_payments WHERE item_id= "'.$id.'" ';
			$db->setQuery($query);
			$db->query();
			$query = 'INSERT INTO #__djcf_payments ( item_id,user_id,method, status) VALUES ( "'.$id.'" ,"'.$user->id.'","'.$ptype.'" ,"Start" )';
			$db->setQuery($query);
			$db->query();*/
			$row->item_id = $id;
			$row->user_id = $user->id;
			$row->method = $ptype;
			$row->status = 'Start';
			$row->ip_address = $_SERVER['REMOTE_ADDR'];
			$row->price = $amount;
			$row->type=0;
			$row->store();
			$itemname = $item->name;
			$item_id = $row->id;
			$item_cid = '&cid='.$item->cat_id;
		}
		$amount = intval(ceil($amount * in_array(strtoupper($this->params['currency_code']), array('IRT','TOM','TOMAN','تومان')) ? 10 : 1));
		$redirect = JRoute::_(JURI::root().'index.php?option=com_djclassifieds&task=processPayment&ptype='.$this->params["plugin_name"].'&pactiontype=notify&id='.$item_id.'&Itemid='.$Itemid);
		$client = new SoapClient('https://rt.sizpay.ir/KimiaIPGRouteService.asmx?WSDL');
		$result = $client->GetToken2($parameters = array(
				'MerchantID'  => $this->params['merchant'],
				'TerminalID'  => $this->params['terminal'],
				'UserName'    => $this->params['username'],
				'Password'    => $this->params['password'],
				'Amount'      => $amount,
				'OrderID'     => time(),
				'ReturnURL'   => $redirect,
				'InvoiceNo'   => time(),
				'DocDate'     => '',
				'ExtraInf'    => $item_id,
				'AppExtraInf' => '',
				'SignData'    => ''
			))->GetToken2Result;
		$result = json_decode($result);
		if (isset($result->ResCod) && in_array($result->ResCod, array('0', '00')))
		{
			$html = '<p style="color:#ff0000; font:18px Tahoma; direction:rtl;">در حال اتصال به درگاه بانکی. لطفا صبر کنید ...</p>
							<form name="frmPay" method="post" action="https://rt.sizpay.ir/Route/Payment">
							<input type="hidden" name="MerchantID" value="'.$this->params['merchant'].'" />
							<input type="hidden" name="TerminalID" value="'.$this->params['terminal'].'" />
							<input type="hidden" name="Username"   value="'.$this->params['username'].'" />
							<input type="hidden" name="Password"   value="'.$this->params['password'].'" />
							<input type="hidden" name="Token"      value="'.$result->Token.'" />
							<input type="hidden" name="SignData"   value="" />
							<noscript><center><input type="submit" value="پرداخت" /></center></noscript>
						</form><script>document.frmPay.submit();</script>';
		}
		else
		{
			if (isset($result->Message)) {
				$error = $result->Message;
			} else {
				$error = 'UnExpected Error!';
			}
			$html = 'ERROR : ' . $error;
		}
		echo $html;
		exit;
	}

	function onPaymentMethodList($val)
	{
		$html = $type = '';
		if($val['type'])
		{
			$type='&type='.$val['type'];
		}
		if($this->params["merchant"] && $this->params["terminal"] && $this->params["username"] && $this->params["password"])
		{
			$paymentLogoPath = JURI::root()."plugins/djclassifiedspayment/".$this->params["plugin_name"]."/".$this->params["plugin_name"]."/images/".$this->params["logo"];
			$form_action = JRoute :: _("index.php?option=com_djclassifieds&task=processPayment&ptype=".$this->params["plugin_name"]."&pactiontype=process&id=".$val["id"].$type, false);
			$html = '<table cellpadding="5" cellspacing="0" width="100%" border="0"><tr>';
				if($this->params["logo"] != "")
				{
					$html .= '<td class="td1" width="160" align="center"><img src="'.$paymentLogoPath.'" title="'. $this->params["payment_method"].'"/></td>';
				}
				$html .= '<td class="td2">
						<h2>SIZPAY</h2>
						<p style="text-align:justify;">'.$this->params["description"].'</p>
					</td>
					<td class="td3" width="130" align="center">
						<a class="button" style="text-decoration:none;" href="'.$form_action.'">'.JText::_('COM_DJCLASSIFIEDS_BUY_NOW').'</a>
					</td>
				</tr>
			</table>';
		}
		return $html;
	}
}

?>